Summary: Samba SMB server.
Name: samba
Version: 2.0.5a
Release: 1
Copyright: GNU GPL Version 2
Group: System Environment/Daemons
Source: ftp://samba.anu.edu.au/pub/samba/samba-%{version}.tar.gz
Source1: samba.log
Source2: mount.smb
Patch: samba-makefilepath.patch
Patch1: smbw.patch
Patch2: samba-glibc21.patch
Patch3: samba-2.0.3-fixinit.patch
Patch4: samba-nsl.patch
Requires: pam >= 0.64
BuildRoot: /var/tmp/samba-root
Prereq: chkconfig fileutils

%description
Samba provides an SMB server which can be used to provide
network services to SMB (sometimes called "Lan Manager")
clients, including various versions of MS Windows, OS/2,
and other Linux machines.  Samba uses NetBIOS over TCP/IP
(NetBT) protocols and does NOT need NetBEUI (Microsoft
Raw NetBIOS frame) protocol.

Samba-2 features an almost working NT Domain Control
capability and includes the new SWAT (Samba Web Administration
Tool) that allows samba's smb.conf file to be remotely managed
using your favourite web browser. For the time being this is
being enabled on TCP port 901 via inetd.

Please refer to the WHATSNEW.txt document for fixup information.
This binary release includes encrypted password support.
Please read the smb.conf file and ENCRYPTION.txt in the
docs directory for implementation details.

NOTE: Red Hat Linux 5.X Uses PAM which has integrated support
for Shadow passwords. Do NOT recompile with the SHADOW_PWD option
enabled. Red Hat Linux has built in support for quotas in PAM.

%package client
Summary: Samba SMB client
Group: Applications/Networking
Obsoletes: smbfs

%description client
Samba-client provides some SMB clients, which complement the
built-in SMB filesystem in Linux. These allow the accessing of
SMB shares, and printing to SMB printers.

%prep
%setup -q
%patch -p1 -b .paths
%patch1 -p1 -b .smbw
%patch2 -p1 -b .glibc21
%patch3 -p1 -b .fixinit
%patch4 -p1 -b .nsl

%build
cd source
autoconf
CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr --libdir=/etc \
  --with-lockdir=/var/lock/samba --with-privatedir=/etc \
  --with-swatdir=/usr/share/swat --with-smbmount --with-automount --with-pam
make CFLAGS="$RPM_OPT_FLAGS" all

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/sbin
mkdir -p $RPM_BUILD_ROOT/etc/codepages/src
mkdir -p $RPM_BUILD_ROOT/etc/{logrotate.d,pam.d}
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/home/samba
mkdir -p $RPM_BUILD_ROOT/usr/{bin,sbin}
mkdir -p $RPM_BUILD_ROOT/usr/share/swat/{images,help,include}
mkdir -p $RPM_BUILD_ROOT/usr/man/{man1,man5,man7,man8}
mkdir -p $RPM_BUILD_ROOT/var/lock/samba
mkdir -p $RPM_BUILD_ROOT/var/log/samba
mkdir -p $RPM_BUILD_ROOT/var/spool/samba

for i in nmblookup smbclient smbpasswd smbstatus testparm testprns \
    smbmount smbmnt smbumount make_smbcodepage make_printerdef rpcclient
do
  install -m755 -s source/bin/$i $RPM_BUILD_ROOT/usr/bin
done

for i in addtosmbpass mksmbpasswd.sh smbtar convert_smbpasswd
do
  install -m755 source/script/$i $RPM_BUILD_ROOT/usr/bin
done

for i in smbd nmbd swat
do
  install -m755 -s source/bin/$i $RPM_BUILD_ROOT/usr/sbin
done

for i in smbclient.1 smbstatus.1 smbtar.1 testparm.1 testprns.1 make_smbcodepage.1 nmblookup.1
do
  install -m644 docs/manpages/$i $RPM_BUILD_ROOT/usr/man/man1
done

for i in 437 737 850 852 861 866 932 936 949 950
do
  install -m644 source/codepages/codepage_def.$i $RPM_BUILD_ROOT/etc/codepages/src
done


# Install SWAT helper files
for i in swat/help/*.html docs/htmldocs/*.html
do
install -m644 $i $RPM_BUILD_ROOT/usr/share/swat/help
done
for i in swat/images/*.gif
do
install -m644 $i $RPM_BUILD_ROOT/usr/share/swat/images
done
for i in swat/include/*.html
do
install -m644 $i $RPM_BUILD_ROOT/usr/share/swat/include
done

# Install other stuff
install -m644 docs/manpages/smb.conf.5 $RPM_BUILD_ROOT/usr/man/man5
install -m644 docs/manpages/lmhosts.5 $RPM_BUILD_ROOT/usr/man/man5
install -m644 docs/manpages/smbpasswd.5 $RPM_BUILD_ROOT/usr/man/man5
install -m644 docs/manpages/samba.7 $RPM_BUILD_ROOT/usr/man/man7
install -m644 docs/manpages/smbmnt.8 $RPM_BUILD_ROOT/usr/man/man8
install -m644 docs/manpages/smbmount.8 $RPM_BUILD_ROOT/usr/man/man8
install -m644 docs/manpages/smbumount.8 $RPM_BUILD_ROOT/usr/man/man8
install -m644 docs/manpages/smbd.8 $RPM_BUILD_ROOT/usr/man/man8
install -m644 docs/manpages/nmbd.8 $RPM_BUILD_ROOT/usr/man/man8
install -m644 docs/manpages/swat.8 $RPM_BUILD_ROOT/usr/man/man8
install -m644 docs/manpages/smbpasswd.8 $RPM_BUILD_ROOT/usr/man/man8
install -m644 packaging/RedHat/smb.conf $RPM_BUILD_ROOT/etc/smb.conf
install -m644 packaging/RedHat/smbusers $RPM_BUILD_ROOT/etc/smbusers
install -m755 packaging/RedHat/smbprint $RPM_BUILD_ROOT/usr/bin
install -m755 packaging/RedHat/smbadduser $RPM_BUILD_ROOT/usr/bin
install -m755 packaging/RedHat/findsmb $RPM_BUILD_ROOT/usr/bin
install -m755 packaging/RedHat/smb.init $RPM_BUILD_ROOT/etc/rc.d/init.d/smb
install -m755 packaging/RedHat/smb.init $RPM_BUILD_ROOT/usr/sbin/samba
install -m644 packaging/RedHat/samba.pamd $RPM_BUILD_ROOT/etc/pam.d/samba
install -m644 $RPM_SOURCE_DIR/samba.log $RPM_BUILD_ROOT/etc/logrotate.d/samba
install -m755 $RPM_SOURCE_DIR/mount.smb $RPM_BUILD_ROOT/sbin
ln -s mount.smb $RPM_BUILD_ROOT/sbin/mount.smbfs
echo 127.0.0.1 localhost > $RPM_BUILD_ROOT/etc/lmhosts


%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add smb
# Build codepage load files
for i in 437 737 850 852 861 866 932 936 949 950; do
  /usr/bin/make_smbcodepage c $i /etc/codepages/src/codepage_def.$i /etc/codepages/codepage.$i
done

# Add swat entry to /etc/services if not already there
if !( grep ^[:space:]*swat /etc/services > /dev/null ) then
        echo 'swat              901/tcp                         # Add swat service used via inetd' >> /etc/services
fi

# Add swat entry to /etc/inetd.conf if needed
if !( grep ^[:space:]*swat /etc/inetd.conf > /dev/null ) then
        echo '#swat      stream  tcp     nowait.400      root /usr/sbin/swat swat' >> /etc/inetd.conf
fi
killall -HUP inetd || :

%preun
if [ $1 = 0 ] ; then
    /sbin/chkconfig --del smb

    for n in /etc/codepages/*; do
	if [ "$n" != "/etc/codepages/src" ]; then
	    rm -rf $n
	fi
    done
        if [ -e /var/lock/samba/browse.dat ]; then
            rm -f /var/lock/samba/browse.dat
    fi
    if [ -e /var/lock/samba/wins.dat ]; then
            rm -f /var/lock/samba/wins.dat
    fi
fi

%postun
if [ $1 = 0 ] ; then
    if [ -e /var/log/samba ]; then
      rm -rf /var/log/samba
    fi
    if [ -e /var/lock/samba ]; then
      rm -rf /var/lock/samba
    fi

    # Remove swat entries from /etc/inetd.conf and /etc/services
    cd /etc
    tmpfile=/etc/tmp.$$
    sed -e '/^[:space:]*swat.*$/d' /etc/inetd.conf > $tmpfile
    mv $tmpfile inetd.conf
    sed -e '/^[:space:]*swat.*$/d' /etc/services > $tmpfile
    mv $tmpfile services
    killall -HUP inetd || :
fi

%triggerpostun -- samba < samba-1.9.18p7
if [ $1 != 0 ]; then
    /sbin/chkconfig --add smb
fi

%files
%defattr(-,root,root)
%doc README COPYING Manifest Read-Manifest-Now
%doc WHATSNEW.txt Roadmap
%doc docs
%doc examples
/usr/sbin/smbd
/usr/sbin/nmbd
/usr/sbin/swat
/usr/bin/addtosmbpass
/usr/bin/mksmbpasswd.sh
/usr/bin/testparm
/usr/bin/testprns
/usr/bin/findsmb
/usr/bin/smbstatus
/usr/bin/nmblookup
/usr/bin/make_smbcodepage
/usr/bin/make_printerdef
/usr/bin/smbpasswd
/usr/bin/smbtar
/usr/bin/convert_smbpasswd
/usr/bin/smbadduser
/usr/share/swat
%config(noreplace) /etc/lmhosts
%config(noreplace) /etc/smb.conf
%config(noreplace) /etc/smbusers
%config /etc/rc.d/init.d/smb
%config /etc/logrotate.d/samba
%config /etc/pam.d/samba
%config /etc/codepages/src/codepage_def.437
%config /etc/codepages/src/codepage_def.737
%config /etc/codepages/src/codepage_def.850
%config /etc/codepages/src/codepage_def.852
%config /etc/codepages/src/codepage_def.861
%config /etc/codepages/src/codepage_def.866
%config /etc/codepages/src/codepage_def.932
%config /etc/codepages/src/codepage_def.936
%config /etc/codepages/src/codepage_def.949
%config /etc/codepages/src/codepage_def.950
/usr/man/man1/smbstatus.1
/usr/man/man1/make_smbcodepage.1
/usr/man/man1/smbtar.1
/usr/man/man1/testparm.1
/usr/man/man1/testprns.1
/usr/man/man1/nmblookup.1
/usr/man/man5/smb.conf.5
/usr/man/man5/lmhosts.5
/usr/man/man5/smbpasswd.5
/usr/man/man7/samba.7
/usr/man/man8/smbd.8
/usr/man/man8/nmbd.8
/usr/man/man8/smbpasswd.8
/usr/man/man8/swat.8

%attr(-,root,nobody)	%dir /home/samba
%dir /etc/codepages
%dir /etc/codepages/src
%dir /var/lock/samba
%dir /var/log/samba
%attr(1777,root,root)	%dir /var/spool/samba

%files client
%defattr(-,root,root)
%ifnarch alpha
/sbin/mount.smb
/sbin/mount.smbfs
/usr/bin/smbmount
/usr/bin/smbmnt
/usr/bin/smbumount
/usr/man/man8/smbmnt.8
/usr/man/man8/smbmount.8 
/usr/man/man8/smbumount.8
%endif
%config(noreplace) /etc/smb.conf
%config(noreplace) /etc/lmhosts
/usr/bin/smbclient
/usr/bin/smbprint
/usr/man/man1/smbclient.1


%changelog
* Wed Jul 21 1999 Bill Nottingham <notting@redhat.com>
- update to 2.0.5
- fix mount.smb - smbmount options changed again.........
- fix postun. oops.
- update some stuff from the samba team's spec file.

* Fri Jun 18 1999 Bill Nottingham <notting@redhat.com>
- split off clients into separate package
- don't run samba by default

* Mon Jun 14 1999 Bill Nottingham <notting@redhat.com>
- fix one problem with mount.smb script
- fix smbpasswd on sparc with a really ugly kludge

* Thu Jun 10 1999 Dale Lovelace <dale@redhat.com>
- fixed logrotate script

* Tue May 25 1999 Bill Nottingham <notting@redhat.com>
- turn of 64-bit locking on 32-bit platforms

* Thu May 20 1999 Bill Nottingham <notting@redhat.com>
- so many releases, so little time
- explicitly uncomment 'printing = bsd' in sample config

* Tue May 18 1999 Bill Nottingham <notting@redhat.com>
- update to 2.0.4a
- fix mount.smb arg ordering

* Fri Apr 16 1999 Bill Nottingham <notting@redhat.com>
- go back to stop/start for restart (-HUP didn't work in testing)

* Fri Mar 26 1999 Bill Nottingham <notting@redhat.com>
- add a mount.smb to make smb mounting a little easier.
- smb filesystems apparently don't work on alpha. Oops.

* Thu Mar 25 1999 Bill Nottingham <notting@redhat.com>
- always create codepages

* Tue Mar 23 1999 Bill Nottingham <notting@redhat.com>
- logrotate changes

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 3)

* Fri Mar 19 1999 Preston Brown <pbrown@redhat.com>
- updated init script to use graceful restart (not stop/start)

* Tue Mar  9 1999 Bill Nottingham <notting@redhat.com>
- update to 2.0.3

* Thu Feb 18 1999 Bill Nottingham <notting@redhat.com>
- update to 2.0.2

* Mon Feb 15 1999 Bill Nottingham <notting@redhat.com>
- swat swat

* Tue Feb  9 1999 Bill Nottingham <notting@redhat.com>
- fix bash2 breakage in post script

* Fri Feb  5 1999 Bill Nottingham <notting@redhat.com>
- update to 2.0.0

* Mon Oct 12 1998 Cristian Gafton <gafton@redhat.com>
- make sure all binaries are stripped

* Thu Sep 17 1998 Jeff Johnson <jbj@redhat.com>
- update to 1.9.18p10.
- fix %triggerpostun.

* Tue Jul 07 1998 Erik Troan <ewt@redhat.com>
- updated postun triggerscript to check $0
- clear /etc/codepages from %preun instead of %postun

* Mon Jun 08 1998 Erik Troan <ewt@redhat.com>
- made the %postun script a tad less agressive; no reason to remove
  the logs or lock file (after all, if the lock file is still there,
  samba is still running)
- the %postun and %preun should only exectute if this is the final
  removal
- migrated %triggerpostun from Red Hat's samba package to work around
  packaging problems in some Red Hat samba releases

* Sun Apr 26 1998 John H Terpstra <jht@samba.anu.edu.au>
- minor tidy up in preparation for release of 1.9.18p5
- added findsmb utility from SGI package

* Wed Mar 18 1998 John H Terpstra <jht@samba.anu.edu.au>
- Updated version and codepage info.
- Release to test name resolve order

* Sat Jan 24 1998 John H Terpstra <jht@samba.anu.edu.au>
- Many optimisations (some suggested by Manoj Kasichainula <manojk@io.com>
- Use of chkconfig in place of individual symlinks to /etc/rc.d/init/smb
- Compounded make line
- Updated smb.init restart mechanism
- Use compound mkdir -p line instead of individual calls to mkdir
- Fixed smb.conf file path for log files
- Fixed smb.conf file path for incoming smb print spool directory
- Added a number of options to smb.conf file
- Added smbadduser command (missed from all previous RPMs) - Doooh!
- Added smbuser file and smb.conf file updates for username map

